<template>
  <div class="signIn_step">
    <PageCard>
      <ThePart1
        @close="close"
        @finish="crossroads"></ThePart1>
      <TheWarning></TheWarning>
    </PageCard>
    <h2
      class="signIn_step-pretitle"
      style="max-width: 210px; margin-left: auto; margin-right: auto; line-height: 1.4;">{{$t('authorization.step3.subtitle')}}</h2>
    <PageCard>
      <ThePart2 @finish="crossroads"></ThePart2>
      <ThePart3 @finish="crossroads"></ThePart3>
      <ThePart4 @finish="crossroads"></ThePart4>
    </PageCard>
    <Loader
      ref="loader"
      :loadFunc="accountCreated">{{loadingText}}
    </Loader>
    <TheSelectNetowrk
      ref="selectNetwork"
      @submit="showPinCode"></TheSelectNetowrk>
  </div>
</template>

<script>
  import ThePart1 from './Step3/ThePart1';
  import ThePart2 from './Step3/ThePart2';
  import ThePart3 from './Step3/ThePart3';
  import ThePart4 from './Step3/ThePart4';
  import TheWarning from './Step3/TheWarning';
  import {Wallet} from "~/services/wallet";
  import Loader from '~/components/UI/Loader';
  import PageCard from '~/components/UI/PageCard';
  import TheSelectNetowrk from './TheSelectNetwork';

  import to from 'await-to-js';

  export default {
    name: "TheStep3",
    data() {
      return {
        loadingText: 'Creating...',
        accountCreated: () => false,
        content: ''
      }
    },
    components: {
      ThePart1,
      ThePart2,
      ThePart3,
      ThePart4,
      TheWarning,
      Loader,
      PageCard,
      TheSelectNetowrk
    },
    methods: {
      close() {
        this.$emit('close');
      },
      async crossroads(keys) {
        //console.log('crossroads', keys);
        this.finishRegistration(keys);
      },
      async finishRegistration(keys) {
        this.loadingText = this.$t('authorization.checking');;
        this.$refs['loader'].show();
        //Try to get accounts info in both networks
        let [err, res] = await to(this.$store.dispatch('signIn/getAccountsByKey', keys.publicKeys[0]));
        switch (res.type) {
          case 'mainnet': {
            //If found user in mainnet
            //Set network to mainnet
            if (res.data.length) {
              const accountName = res.data[res.data.length - 1];
              this.setStates({
                publicKey: keys.publicKeys[0],
                privateKey: keys.privateKeys[0],
                accountName,
                demo: false,
              })
            }
            break;
          }
          case 'testnet': {
            //If found user in testnet
            //Set network to mainnet
            if (res.data.length) {
              const accountName = res.data[res.data.length - 1];
              this.setStates({
                publicKey: keys.publicKeys[0],
                privateKey: keys.privateKeys[0],
                accountName
              })
            } else {
              this.createUser(keys);
            }
            break;
          }
        }
      },
      async createUser(keys) {
        this.loadingText = this.$t('authorization.creating');
        const accountName = this.$store.state.signIn.accountname;
        const [e, r] = await to(this.$store.dispatch('user/create', {
          net: 'testnet',
          username: this.$store.state.signIn.accountname,
          public: {
            owner: keys.publicKeys[1] ? keys.publicKeys[1] : keys.publicKeys[0],
            active: keys.publicKeys[0],
          },
          signature: 'sign',
          timestamp: new Date().getTime()
        }));
        if (!e) {
          this.setStates({
            publicKey: keys.publicKeys[0],
            privateKey: keys.privateKeys[0],
            accountName
          });
        }
        this.$refs['loader'].close();
        this.accountCreated = () => true;
        this.disabled = false;
      },
      setStates({demo = true, ...data} = {}) {
        this.$store.commit('wallet/SET_DATA', {
          name: data.accountName
        });
        this.$store.dispatch('wallet/saveKeys', data);
        localStorage.setItem('accountname', data.accountName);
        this.$nextTick(async _ => {
          const res = await this.$store.dispatch('common/changeGameType', demo);
          this.$store.commit('signIn/CLEAR');
          this.$refs['loader'].close();
          if (res.accountsList && res.accountsList.length > 1) {
            this.$refs['selectNetwork'].show();
            this.$refs['selectNetwork'].selectAccounts(res);
          } else {
            this.showPinCode();
          }
        });
      },
      showPinCode() {
        this.close();
        this.$nextTick(_ => {
          this.$store.commit('pincode/SET_SHOW_PINCODE', {show: true, navs: false});
        });
      }
    },
    mounted() {
      this.loadingText = this.$t('authorization.creating');
    }
  }
</script>
